import typing
import helpers

class GlobalUnderTest():
    def foo(a: 'GlobalUnderTest'):
        pass

print(typing.get_type_hints(GlobalUnderTest.foo))

def working():
    class A():
        pass
        
    class UnderTest():
        def foo(a: A):
            pass
            
    print(typing.get_type_hints(UnderTest.foo))


def not_working():
    class A():
        pass
        
    class UnderTest():
        #@helpers.store_namespace(locals()) # does not work: locals() does not contain UnderTest or A!
        def foo(a: 'UnderTest'):
            pass
            
    UnderTest.foo.__locals__ = locals()
            
    print(helpers.get_type_hints(UnderTest.foo))
    
    
working()
not_working()